(*
 * <COPYRIGHT>
 * Copyright 2005 Gerd Stolpmann
 *
 * <GPL>
 * This file is part of UMLMON.
 *
 * UMLMON is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * UMLMON is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with UMLMON; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * </>
 *)

(* $Id: umldir_client.ml 191 2005-10-14 19:04:52Z gerd $ *)

open Umlmonctrl_aux

module Dir = Umlmonctrl_clnt.Directory.V1

let vardir() =
  try
    Sys.getenv "UMLMON_DIR"
  with
      Not_found -> "/var/lib/umlmon"
;;


let create_client ues host =
  if host = "localhost" then
    Dir.create_client
      ~esys:ues
      (Rpc_client.Unix (Filename.concat (vardir()) "directory/directory"))
      Rpc.Tcp
  else
    let serv =
      try Unix.getservbyname "umldir" "tcp"
      with Not_found -> failwith "umldir/tcp service not found (probably in /etc/services)" in
    let dir = Dir.create_client
		~esys:ues
		(Rpc_client.Inet(host, serv.Unix.s_port))
		Rpc.Tcp in
    dir
;;
